// Code generated by go-swagger; DO NOT EDIT.

package users

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the generate command

import (
	"net/http"

	middleware "github.com/go-openapi/runtime/middleware"
)

// UsersHandlerFunc turns a function with the right signature into a users handler
type UsersHandlerFunc func(UsersParams, *ticketboss) middleware.Responder

// Handle executing the request and returning a response
func (fn UsersHandlerFunc) Handle(params UsersParams, principal *ticketboss) middleware.Responder {
	return fn(params, principal)
}

// UsersHandler interface for that can handle valid users params
type UsersHandler interface {
	Handle(UsersParams, *ticketboss) middleware.Responder
}

// NewUsers creates a new http.Handler for the users operation
func NewUsers(ctx *middleware.Context, handler UsersHandler) *Users {
	return &Users{Context: ctx, Handler: handler}
}

/*Users swagger:route GET /users Users users

User login validation - Email and password need to be passed through Basic Authentication.

JSON Response is provided with respective success or fail details.

*/
type Users struct {
	Context *middleware.Context
	Handler UsersHandler
}

func (o *Users) ServeHTTP(rw http.ResponseWriter, r *http.Request) {
	route, rCtx, _ := o.Context.RouteInfo(r)
	if rCtx != nil {
		r = rCtx
	}
	var Params = NewUsersParams()

	uprinc, aCtx, err := o.Context.Authorize(r, route)
	if err != nil {
		o.Context.Respond(rw, r, route.Produces, route, err)
		return
	}
	if aCtx != nil {
		r = aCtx
	}
	var principal *ticketboss
	if uprinc != nil {
		principal = uprinc.(*ticketboss) // this is really a ticketboss, I promise
	}

	if err := o.Context.BindValidRequest(r, route, &Params); err != nil { // bind params
		o.Context.Respond(rw, r, route.Produces, route, err)
		return
	}

	res := o.Handler.Handle(Params, principal) // actually handle the request

	o.Context.Respond(rw, r, route.Produces, route, res)

}
